<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Order List - Filter Order</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Task 45.50</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Hieu Nguyen</a>
        </div>
      </div>


      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order List - Filter Order</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Order List - Filter Order</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Order List - Filter Order</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="text-center mt-2 mb-2">
          <h3>Danh sách Đơn hàng</h3>
        </div>
        <div class="jumbotron container-fluid py-4 px-4">
          <div class="row form-group">
            <div class="col-md-2">
              <label>Trạng thái</label>
            </div>
            <div class="col-md-3">
              <select id="select-filter-trangThai" class="form-control">
                <option value="">(all)</option>
                <option value="open">open</option>
                <option value="confirmed">confirmed</option>
                <option value="cancel">cancel</option>
              </select>
            </div>
            <div class="col-md-2">
              <label>Loại pizza</label>
            </div>
            <div class="col-md-3">
              <select id="select-filter-loaiPizza" class="form-control">
                <option value="">(all)</option>
                <option value="hawaii">Hawaii</option>
                <option value="seafood">Seafood</option>
                <option value="bacon">Bacon</option>
              </select>
            </div>
            <div class="col-md-2 ml-auto">
              <button class="btn btn-primary" id="btn-filter-order">Lọc</button>
            </div>
          </div>
      </div>
    
      <div id="modal-order-detail" class="modal fade" tabindex="-1">
        <div class="modal-dialog modal-xl" style="max-width:900px">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Order Detail</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Order Id</label>
                  <div class="col-sm-4">
                    <input id="input-order-id" type="text" class="form-control" placeholder="Order ID ...">
                  </div>
                  <label class="col-sm-2 col-form-label">Cỡ Combo</label>
                  <div class="col-sm-4">
                    <select id="select-size" class="form-control">
                      <option value=""> Chọn cỡ Combo</option>
                      <option value="S"> Nhỏ</option>
                      <option value="M"> Vừa</option>
                      <option value="L"> Lớn</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Đường kính</label>
                  <div class="col-sm-4">
                    <input id="input-diameter" type="text" class="form-control" placeholder="cm ..."> 
                  </div>
                  <label class="col-sm-2 col-form-label">Sườn (miếng)</label>
                  <div class="col-sm-4">
                    <input id="input-suon" type="text" class="form-control" placeholder="..."> 
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Loại pizza</label>
                  <div class="col-sm-4">
                    <input id="input-pizza-type" type="text" class="form-control" placeholder="Loại pizza ...">
                  </div>
                  <label class="col-sm-2 col-form-label">Salad</label>
                  <div class="col-sm-4">
                    <input id="input-salad" type="text" class="form-control" placeholder="gram ..."> 
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Đồ uống</label>
                  <div class="col-sm-4">
                    <select class="form-control" id="select-drink">
                      <option value="">Chọn đồ uống</option>
                    </select>
                  </div>
                  <label class="col-sm-2 col-form-label">Số đồ uống</label>
                  <div class="col-sm-4">
                    <input id="input-so-nuoc-uong" type="text" class="form-control" placeholder="..."> 
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Mã Voucher</label>
                  <div class="col-sm-4">
                    <input id="input-voucher" type="text" class="form-control" placeholder="Mã Voucher ..."> 
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Thành tiền</label>
                  <div class="col-sm-4">
                    <input id="input-price" type="text" class="form-control" placeholder="..."> 
                  </div>
                  <label class="col-sm-2 col-form-label">Giảm giá</label>
                  <div class="col-sm-4">
                    <input id="input-discount" type="text" class="form-control" placeholder="..."> 
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Họ và tên</label>
                  <div class="col-sm-4">
                    <input id="input-fullname" type="text" class="form-control" placeholder="Họ và tên ..."> 
                  </div>
                  <label for="" class="col-sm-2 col-form-label">Email</label>
                  <div class="col-sm-4">
                    <input id="input-email" type="email" class="form-control" placeholder="Email ..."> 
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Số điện thoại</label>
                  <div class="col-sm-4">
                    <input id="input-mobile" type="text" class="form-control" placeholder="Số điện thoại ...">
                  </div>
                  <label class="col-sm-2 col-form-label">Địa chỉ</label>
                  <div class="col-sm-4">
                    <input id="input-address" type="text" class="form-control" placeholder="Địa chỉ ..."> 
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Lời nhắn</label>
                  <div class="col-sm-4">
                    <input id="input-message" class="form-control" placeholder="Lời nhắn ..."></input>
                  </div>
                  <label class="col-sm-2 col-form-label">Trạng thái đơn</label>
                  <div class="col-sm-4">
                    <input id="input-order-status" type="text" class="form-control" placeholder="Trạng thái ..."> 
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Ngày tạo đơn</label>
                  <div class="col-sm-4">
                    <input id="input-create-date" type="text" class="form-control" placeholder="Ngày tạo đơn ...">
                  </div>
                  <label class="col-sm-2 col-form-label">Ngày cập nhật</label>
                  <div class="col-sm-4">
                    <input id="input-update-date" type="text" class="form-control" placeholder="Ngày cập nhật ..."> 
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-success mr-1" id="btn-confirm" >Confirm</button>
              <button class="btn btn-info" id="btn-cancel">Cancel</button>
            </div>
          </div>
        </div>
      </div>
    
      <div class="container-fluid">
        <table class="table table-bordered table-striped table-hover" id="order-table">
          <thead>
            <tr>
              <th>Mã order</th>
              <th>Size</th>
              <th>Loại pizza</th>
              <th>Đồ uống</th>
              <th>Giá</th>
              <th>Họ và Tên</th>
              <th>Số ĐT</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
          </thead>
        </table>
      </div>

    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> Task 45.50 29-06-2022.
  </footer>


</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // mảng orders
  var gOrderDb = {
    orders: [],
    filterOrder: function(paramFilter) {
      var result = [];
      // lọc dữ liệu order
      result = this.orders.filter(function(order) {
        return ((paramFilter.trangThai == "" || order.trangThai.toLowerCase().includes(paramFilter.trangThai.toLowerCase())) && 
                (paramFilter.loaiPizza == "" || order.loaiPizza.toLowerCase().includes(paramFilter.loaiPizza.toLowerCase()))
        )
      })
      return result
    }
  }
  var gColNameList = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "detail"];
  const gCOL_ORDER_ID = 0;
  const gCOL_KICH_CO = 1;
  const gCOL_LOAI_PIZZA = 2;
  const gCOL_NUOC_UONG = 3;
  const gCOL_THANH_TIEN = 4;
  const gCOL_HO_TEN = 5;
  const gCOL_SO_DIEN_THOAI = 6;
  const gCOL_TRANG_THAI = 7;
  const gCOL_DETAIL = 8;
  var gId = 0;
  var gOrderId = "";
  var gOrderTable = $("#order-table").DataTable({
      columns: [
        {data: gColNameList[gCOL_ORDER_ID]},
        {data: gColNameList[gCOL_KICH_CO]},
        {data: gColNameList[gCOL_LOAI_PIZZA]},
        {data: gColNameList[gCOL_NUOC_UONG]},
        {data: gColNameList[gCOL_THANH_TIEN]},
        {data: gColNameList[gCOL_HO_TEN]},
        {data: gColNameList[gCOL_SO_DIEN_THOAI]},
        {data: gColNameList[gCOL_TRANG_THAI]},
        {data: gColNameList[gCOL_DETAIL]},
      ],
      columnDefs: [
        {
          targets: gCOL_DETAIL,
          defaultContent: `
            <button class="btn btn-link order-detail" title='Chi tiết'><i class='far fa-edit'></i></button>
          `
        }
      ]
    });

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function() {
    callAjaxApiGetAllOrders();
    loadDataToTable(gOrderDb.orders)
    callAjaxApiGetDrinkList()
  })
  $("#btn-filter-order").click(onBtnFilterOrderClick)
  $("#order-table").on("click", ".order-detail", function() {
      onBtnOrderDetailClick(this); // this là button được ấn
    });
  $("#btn-confirm").click(onBtnConfirmClick);
  $("#btn-cancel").click(onBtnCancelClick);

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  //hàm xử lý sự kiện lọc order
  function onBtnFilterOrderClick() {
      var vFilterObj = {
        trangThai: "",
        loaiPizza: ""
      };
      //B1: thu thập dữ liệu
      getFilterData(vFilterObj);
      //B2: kiểm tra (bỏ qua)
      //B3 lọc dữ liệu và hiển thị kết quả
      var vFilteredOrders = gOrderDb.filterOrder(vFilterObj);
      loadDataToTable(vFilteredOrders)
    }
  function onBtnOrderDetailClick(paramDetailButton) {
    var vRowSelected = $(paramDetailButton).parents('tr');
    var vDataTableRow = gOrderTable.row(vRowSelected); 
    var vRowData = vDataTableRow.data();
    gId = vRowData.id;
    gOrderId = vRowData.orderId;
    console.log("Đã ấn nút Chi tiết của hàng có Index là " + vDataTableRow.index() + ". Thông tin của hàng là:");
    console.log("Id = " + gId + ". Order Id = " + gOrderId);
    callAjaxApiGetOrderByOrderId(gOrderId);
    $("#modal-order-detail").modal("show")
  }
  function onBtnConfirmClick() {
    console.log("%cNút confirm được ấn. Id là: " + gId, "color:green");
    var vObjectRequest = {
      trangThai: "confirmed" //3 trang thai open, confirmed, cancel
    }
    //B3: gọi api update order
    callAjaxApiUpdateOrder(vObjectRequest);
    //B4: xử lý hiển thị
    callAjaxApiGetAllOrders();
    loadDataToTable(gOrderDb.orders)
    $("#modal-order-detail").modal("hide")
  }
  function onBtnCancelClick() {
    console.log("%cNút cancel được ấn. Id là: " + gId, "color:blue");
    var vObjectRequest = {
      trangThai: "cancel" //3 trang thai open, confirmed, cancel
    }
    //B3: gọi api update order
    callAjaxApiUpdateOrder(vObjectRequest);
    //B4: xử lý hiển thị
    callAjaxApiGetAllOrders();
    loadDataToTable(gOrderDb.orders)
    $("#modal-order-detail").modal("hide")
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function callAjaxApiGetAllOrders() {
    $.ajax({
        async: false,
        url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          gOrderDb.orders = responseObject;
          console.log(gOrderDb.orders);
        },
        error: function(error){
          console.assert(error.responseText);
        }
    });
  }
  function loadDataToTable(paramOrderList) {
    $("#order-table").DataTable().clear()
      .rows.add(paramOrderList)
      .draw()
  }
  function callAjaxApiGetDrinkList() {
    $.ajax({
      async: false,
      url: "http://42.115.221.44:8080/devcamp-pizza365/drinks/",
      type: "GET",
      dataType: 'json',
      success: function(responseObject){
        //console.log(responseObject);
        loadDataToSelectDrink(responseObject)
      },
      error: function(error){
        console.assert(error.responseText);
      }
    });
  }
  function loadDataToSelectDrink(paramDrinkList) {
    for (let bDrink of paramDrinkList) {
      $("#select-drink").append($("<option>").val(bDrink.maNuocUong).text(bDrink.tenNuocUong))
    }
  }
  function callAjaxApiGetOrderByOrderId(paramOrderId) {
    $.ajax({
      async: false,
      url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + paramOrderId,
      type: "GET",
      dataType: 'json',
      success: function(responseObject){
        console.log(responseObject);
        loadDataToOrderDetailModal(responseObject)
      },
      error: function(error){
        console.assert(error.responseText);
      }
    });
  }
  function loadDataToOrderDetailModal(paramOrderObj) {
    $("#input-order-id").val(paramOrderObj.orderId);
    $("#select-size").val(paramOrderObj.kichCo);
    $("#input-diameter").val(paramOrderObj.duongKinh);
    $("#input-suon").val(paramOrderObj.suon);
    $("#input-pizza-type").val(paramOrderObj.loaiPizza);
    $("#input-salad").val(paramOrderObj.salad);
    $("#select-drink").val(paramOrderObj.idLoaiNuocUong);
    $("#input-so-nuoc-uong").val(paramOrderObj.soLuongNuoc);
    $("#input-voucher").val(paramOrderObj.idVourcher);
    $("#input-price").val(paramOrderObj.thanhTien);
    $("#input-discount").val(paramOrderObj.giamGia);
    $("#input-fullname").val(paramOrderObj.hoTen);
    $("#input-email").val(paramOrderObj.email);
    $("#input-mobile").val(paramOrderObj.soDienThoai);
    $("#input-address").val(paramOrderObj.diaChi);
    $("#input-message").val(paramOrderObj.loiNhan);
    $("#input-order-status").val(paramOrderObj.trangThai);
    $("#input-create-date").val(paramOrderObj.ngayTao);
    $("#input-update-date").val(paramOrderObj.ngayCapNhat);
  }
  function callAjaxApiUpdateOrder(paramObjectRequest) {
    $.ajax({
      async: false,
      url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gId,
      type: "PUT",
      data: JSON.stringify(paramObjectRequest),
      contentType: "application/json;charset=UTF-8",
      dataType: 'json',
      success: function(responseObject){
        alert("Cập nhật thành công cho order có Id " + gId + "! Xem response ở console")
        console.log(responseObject);
      },
      error: function(error){
        alert("Cập nhật thất bại! Xem response ở console")
        console.assert(error.responseText);
      }
    });
  }
  // hàm thu thập dữ liệu
  function getFilterData(paramFilterObj) {
    paramFilterObj.trangThai = $("#select-filter-trangThai").val();
    paramFilterObj.loaiPizza = $("#select-filter-loaiPizza").val();
  }

</script>
</html>
